﻿//=================================================================
//
//		   		Camel Figurine Interacter - Plugin
//						Autor: katzerle
//			Honorbuddy Plugin - www.thebuddyforum.com
//        Credits to highvoltz and all the brave Testers
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Runtime.Serialization;
using System.Xml;
using Styx;
using Styx.Common;

using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.WoWInternals;
using ObjectManager = Styx.WoWInternals.ObjectManager;

namespace katzerle
{
    class CamelSettings
    {
        string File = "Plugins\\CamelFigurine\\config\\";
        public CamelSettings()
        {
            if (ObjectManager.Me != null)
                try
                {
                    Load();
                }
                catch (Exception e)
                {
                   
                    Logging.Write(e.Message);
                }
        }

        public bool Default = true;
        public bool Dormus = true;
        public string PullDormus = "";
        public bool Alert = true;
        public bool Collect = true;

        public void Load()
        {
            //    XmlTextReader reader;
            XmlDocument xml = new XmlDocument();
            XmlNode xvar;

            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);
            sPath = Path.Combine(sPath, File);

            if (!Directory.Exists(sPath))
            {
                Logging.Write("Plugin Camel: Creating config directory");
                Directory.CreateDirectory(sPath);
            }

            sPath = Path.Combine(sPath, "Camel.config");

            Logging.Write("Plugin Camel: Loading config file: {0}", sPath);
            System.IO.FileStream fs = new System.IO.FileStream(@sPath, System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.ReadWrite);
            try
            {
                xml.Load(fs);
                fs.Close();
            }
            catch (Exception e)
            {
                Logging.Write(e.Message);
                Logging.Write("Plugin Camel: Continuing with Default Config Values");
                fs.Close();
                return;
            }

            //            xml = new XmlDocument();

            try
            {
                //                xml.Load(reader);
                if (xml == null)
                    return;

                xvar = xml.SelectSingleNode("//Camel/Default");
                if (xvar != null)
                {
                    Default = Convert.ToBoolean(xvar.InnerText);
                    Logging.Write("Plugin Camel: " + xvar.Name + "=" + Default.ToString());
                }

                xvar = xml.SelectSingleNode("//Camel/Dormus");
                if (xvar != null)
                {
                    Dormus = Convert.ToBoolean(xvar.InnerText);
                    Logging.Write("Plugin Camel: " + xvar.Name + "=" + Dormus.ToString());
                }

                xvar = xml.SelectSingleNode("//Camel/PullDormus");
                if (xvar != null)
                {
                    PullDormus = Convert.ToString(xvar.InnerText);
                    Logging.Write("Plugin Camel: " + xvar.Name + "=" + PullDormus.ToString());
                }

                xvar = xml.SelectSingleNode("//Camel/Alert");
                if (xvar != null)
                {
                    Alert = Convert.ToBoolean(xvar.InnerText);
                    Logging.Write("Plugin Camel: " + xvar.Name + "=" + Alert.ToString());
                }

                xvar = xml.SelectSingleNode("//Camel/Collect");
                if (xvar != null)
                {
                    Collect = Convert.ToBoolean(xvar.InnerText);
                    Logging.Write("Plugin Camel: " + xvar.Name + "=" + Collect.ToString());
                }

            }
            catch (Exception e)
            {
                Logging.Write("Plugin Camel: PROJECTE EXCEPTION, STACK=" + e.StackTrace);
                Logging.Write("Plugin Camel: PROJECTE EXCEPTION, SRC=" + e.Source);
                Logging.Write("Plugin Camel: PROJECTE : " + e.Message);
            }
        }  
    }
}
