﻿//=================================================================
//
//		  		 Camel Figurine Interacter - Plugin
//						Autor: katzerle
//			Honorbuddy Plugin - www.thebuddyforum.com
//        Credits to highvoltz and all the brave Testers
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Media;
using Styx;
using Styx.Combat;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.CommonBot;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Frames;
using Styx.CommonBot.Inventory;

using Styx.Common;

namespace katzerle
{
    public partial class CamelUI : Form
    {
        public CamelUI()
        {
            InitializeComponent();
            CBDefault.Checked = Camel.Settings.Default;
            CBDormus.Checked = Camel.Settings.Dormus;
            TBPullDormus.Text = Camel.Settings.PullDormus;
            CBAlert.Checked = Camel.Settings.Alert;
            CBCollect.Checked = Camel.Settings.Collect;
        }

        private void CBDefault_CheckedChanged(object sender, EventArgs e)
        {
            if (CBDefault.Checked)
                TBPullDormus.Enabled = false;
            else
                TBPullDormus.Enabled = true;
        }
        
        private void BSave_Click(object sender, EventArgs e)
        {
            string File = "Plugins\\CamelFigurine\\config\\";
             Logging.Write("Plugin Camel: SettingsSaved!");
           

            XmlDocument xml;
            XmlElement root;
            XmlElement element;
            XmlText text;
            XmlComment xmlComment;

            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);

            Camel.Settings.Default = CBDefault.Checked;
            Camel.Settings.Dormus = CBDormus.Checked;
            Camel.Settings.PullDormus = TBPullDormus.Text;
            Camel.Settings.Alert = CBAlert.Checked;
            Camel.Settings.Collect = CBCollect.Checked;

// ---------- Check Plausibility of the Config ----------------------------
			if (!CBDefault.Checked && (TBPullDormus.Text == ""))
            {
                Logging.Write("Plugin Camel: You must insert a Pullspell");
                CBDefault.Checked = true;
                Camel.Settings.Default = true;
            }
 			if (!(SpellManager.HasSpell(Camel.Settings.PullDormus))
				&& !(SpellManager.HasSpell("Shadow Word: Pain"))
				&& !(SpellManager.HasSpell("Ice Lance"))
				&& !(SpellManager.HasSpell("Charge"))
				&& !(SpellManager.HasSpell("Serpent Sting"))
				&& !(SpellManager.HasSpell("Thrown"))
				&& !(SpellManager.HasSpell("Icy Touch"))
				&& !(SpellManager.HasSpell("Hand of Reckoning"))
				&& !(SpellManager.HasSpell("Flame Shock"))
				&& !(SpellManager.HasSpell("Corruption"))
				&& !(SpellManager.HasSpell("Moonfire")))
           {
                Logging.Write("Plugin Camel: Don't have a Pull Spell - please check your Config and config one");
                Camel.Settings.Default = true;
                CBDefault.Checked = true;
            }

			
            sPath = Path.Combine(sPath, File);

            if (!Directory.Exists(sPath))
            {
                Logging.Write("Plugin Camel: Creating config directory");
                Directory.CreateDirectory(sPath);
            }

            sPath = Path.Combine(sPath, "Camel.config");

            Logging.Write("Plugin Camel: Saving config file: {0}", sPath);
            xml = new XmlDocument();
            XmlDeclaration dc = xml.CreateXmlDeclaration("1.0", "utf-8", null);
            xml.AppendChild(dc);

            xmlComment = xml.CreateComment(
                "=======================================================================\n" +
                ".CONFIG  -  This is the Config File For Plugin Camel\n\n" +
                "XML file containing settings to customize in the Camel Plugin\n" +
                "It is STRONGLY recommended you use the Configuration UI to change this\n" +
                "file instead of direct changein it here.\n" +
                "========================================================================");

            //let's add the root element
            root = xml.CreateElement("Camel");
            root.AppendChild(xmlComment);

            //let's add another element (child of the root)
            element = xml.CreateElement("Default");
            text = xml.CreateTextNode(CBDefault.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Dormus");
            text = xml.CreateTextNode(CBDormus.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("PullDormus");
            text = xml.CreateTextNode(TBPullDormus.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Alert");
            text = xml.CreateTextNode(CBAlert.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Collect");
            text = xml.CreateTextNode(CBCollect.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            xml.AppendChild(root);

            System.IO.FileStream fs = new System.IO.FileStream(@sPath, System.IO.FileMode.Create,
                                                               System.IO.FileAccess.Write);
            try
            {
                xml.Save(fs);
                fs.Close();
            }
            catch (Exception np)
            {
                Logging.Write(np.Message);
            }
        }

        private void BTest_Click(object sender, EventArgs e)
        {
            string File = "Plugins\\CamelFigurine\\";
            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);
            sPath = Path.Combine(sPath, File);
            sPath = Path.Combine(sPath, "siren1.wav");
            new SoundPlayer(sPath).Play();
        }
    }
}
